/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.TipoDomicilio;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoDomicilio;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaTipoDomicilioController")
@Scope("prototype")
public class BusquedaTipoDomicilioController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoDomicilio> plwTipoDomicilio;
    private MyListbox tipoDomicilioList;
    private Paging pagingTipoDomicilio;
    private Textbox txtNome;
    private Textbox txtCve;

    public Paging getPagingTipoDomicilio() {
        return pagingTipoDomicilio;
    }

    public void setPagingTipoDomicilio(Paging pagingTipoDomicilio) {
        this.pagingTipoDomicilio = pagingTipoDomicilio;
    }

    public MyListbox getTipoDomicilioList() {
        return tipoDomicilioList;
    }

    public void setTipoDomicilioList(MyListbox tipoDomicilioList) {
        this.tipoDomicilioList = tipoDomicilioList;
    }

    public Textbox getTxtCve() {
        return txtCve;
    }

    public void setTxtCve(Textbox txtCve) {
        this.txtCve = txtCve;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tipoDomicilioList.setItemRenderer(new RenderTipoDomicilio());
        tipoDomicilioList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoDomicilio a = (TipoDomicilio) tipoDomicilioList.getSelected();
                verTipoDomicilio(a);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    private void verTipoDomicilio(TipoDomicilio a) {
        if (a == null) {
            return;
        }

        Map args = new HashMap();
        args.put("busquedaTipoDomicilioController", this);
        args.put("tipoDomicilio", a);
        args.put("tipoDomicilioList", tipoDomicilioList);

        openWindow("/gui/senda_amigo/editarTipoDomicilio.zul",
                Labels.getLabel("busquedaTipoDomicilioController.window.title"), args, MODAL);
    }

    public void refreshLista() {
        HibernateSearchObject<TipoDomicilio> tipoDomicilioBusqueda =
                new HibernateSearchObject<TipoDomicilio>(TipoDomicilio.class,
                pagingTipoDomicilio.getPageSize());

        if (!txtNome.getText().isEmpty()) {
            tipoDomicilioBusqueda.addFilterLike("desctipo",
                    "%" + txtNome.getText().trim().concat("%"));
        }

        if (!txtCve.getText().isEmpty()) {
            tipoDomicilioBusqueda.addFilterEqual("cvetipodomicilio", txtCve.getText());
        }

        tipoDomicilioBusqueda.addSortAsc("desctipo");
        tipoDomicilioBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwTipoDomicilio.init(tipoDomicilioBusqueda, tipoDomicilioList, pagingTipoDomicilio);

        if (tipoDomicilioList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTipoDomicilioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoDomicilio(new TipoDomicilio());
    }
}
